/* header file for hds */

#define MAXFNAME    20
#define MAXFIELD    20
#define MAXSLEN     1024
#define MAXSLENG    ( MAXSLEN + 2*sizeof(short) ) /* add 4 for length & terminator */

#define READ_ONLY   1

#define EMERGENCY	(4096)

#define NOT_PROTECTED	0
#define PROTECTED		1

/* file type for Mac dbs */

#define FTYPE		'HDDB'

/* security codes */

#define SEC_ON     -1
#define SEC_OFF     0

/* record types */

#define ILLEGAL_REC             0
#define NORMAL_REC              1
#define DATA_REC                2
#define DESCR_REC               3
#define DESCRGD_REC				4

/* field types */

#define ILLEGA_F                0
#define WORD_F                  1
#define LONG_F                  2
#define FLOAT_F                 3
#define DOUBLE_F                4
#define PTR_F                   5
#define STRING_F                6
#define MARK_F                  7

#define FIXED_STRING            -

/* Function indices for hdsnext */

#define THIS_RECORD				0
#define ENTER_DATA				1
#define BEFORE_RIGHT			2
#define BEFORE_DOWN				3
#define BEFORE_LEFT				4
#define LEAVE_DATA				5
#define ATTEMPT_RIGHT			6

/* errors */

#define OK                       0
#define OUT_OF_MEMORY           -1
#define CANT_OPEN               -2
#define BAD_SEEK                -3
#define BAD_READ                -4
#define NOT_ACTIVE              -5
#define BAD_RECORD              -6
#define TOO_MANY_FIELDS         -7
#define NO_MORE_FIELDS          -8
#define BAD_STRING				-9
#define BAD_FIELD_TYPE			-10
#define NO_SUCH_WAY				-11
#define WRONG_FIELD_NUMBER		-12
#define PROTECTED_RECORD		-13
#define BAD_WRITE				-14
#define NO_WRITE_PERMISSION		-15
#define NO_BRANCH				-16
#define NO_NORMAL_REC			-17
#define ALREADY_DATA			-18
#define NO_DATA_FIELDS			-19
#define BRANCH_EXISTS			-20
#define NOT_FOUND				-21
#define LABEL_OVERFLOW			-22
#define BAD_SEQ					-23
#define SORT_TOO_MUCH			-24
#define NO_LINK					-25
#define NO_MARK					-26
#define MANY_LINKS				-27
#define WRONG_REC_ORDER			-28
#define PROTECTED_BRANCH		-29
#define DESCRIPTOR_NOT_FOUND	-30
#define PROTECTED_RIGHT			-31
#define ALREADY_DELETED			-32

#define MAXERR					32

typedef union par {
    short int   w;
    short int   m;
    long int    l;
    float       f;
    double      d;
    long int    p;
    char        *s;
} PAR, *PPAR;

typedef struct {
	char *s;								/* file name */
#ifdef MAC
	short vRefNum;							/* Volume Reference # (only for MAC) */
	long parID;								/* directory ID (only for MAC) */
	unsigned long creator;					/* creator only for hdscreat */
#endif
} FILESPEC;

typedef int (*HDS_func) (void);				/* pointer to functions used in traversals */

#include "hdsopen.h"
#include "hdsinq.h"
#include "hdsinse.h"
#include "hdsmisc.h"
#include "hdsnav.h"
#include "hdssrch.h"
#include "hdsinout.h"
#include "hdslink.h"

#ifdef MAC
#include "hdsmac.h"
#include "hdserrors.h"
#endif

